//	VerifyVersionInfo APIpăo[W擾
//	Visual C++ 2005/2008/2013	32/64bit

#include <windows.h>
#include <stdio.h>
#include <tchar.h>

//	VerifyVersionInfo APIgOSVERINFOEX̎w肵DWORD̒l擾
void getVerDword(OSVERSIONINFOEX* ver, DWORD* dwp, DWORD mask, LONGLONG cmask);

//	VerifyVersionInfo APIgOSVERINFOEX̎w肵WORD̒l擾
void getVerWord(OSVERSIONINFOEX* ver, WORD* wp, DWORD mask, LONGLONG cmask);

//	VerifyVersionInfo APIgOSVERINFOEX̎w肵BYTE̒l擾
void getVerByte(OSVERSIONINFOEX* ver, BYTE* bp, DWORD mask, LONGLONG cmask);

int WINAPI _tWinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst, LPTSTR lpsCmdLine, int nCmdShow){
	OSVERSIONINFOEX ver;
	ZeroMemory(&ver, sizeof(ver));
	ver.dwOSVersionInfoSize = sizeof(ver);

	LONGLONG cmask = 0;
	DWORD mask;
	cmask = VerSetConditionMask(cmask, VER_MAJORVERSION, VER_GREATER_EQUAL);
	mask = VER_MAJORVERSION;
	getVerDword(&ver, &ver.dwMajorVersion, mask, cmask);

	cmask = VerSetConditionMask(cmask, VER_MINORVERSION, VER_GREATER_EQUAL);
	mask |= VER_MINORVERSION;
	getVerDword(&ver, &ver.dwMinorVersion, mask , cmask);

	cmask = VerSetConditionMask(cmask, VER_SERVICEPACKMAJOR, VER_GREATER_EQUAL);
	mask |= VER_SERVICEPACKMAJOR;
	getVerWord(&ver, &ver.wServicePackMajor, mask , cmask);

	cmask = VerSetConditionMask(cmask, VER_BUILDNUMBER, VER_GREATER_EQUAL);
	mask |= VER_BUILDNUMBER;
	getVerDword(&ver, &ver.dwBuildNumber,mask , cmask);

	TCHAR buf[64];
	_stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("W[%d }Ci[%d\nT[rXpbN%d\nrh%d"), ver.dwMajorVersion,ver.dwMinorVersion,ver.wServicePackMajor,ver.dwBuildNumber);
	MessageBox(0, buf, _TEXT("Windowso[W"), MB_OK);
}

//	VerifyVersionInfo APIgOSVERINFOEX̎w肵DWORD̒l擾

void getVerDword(OSVERSIONINFOEX* ver, DWORD* dwp, DWORD mask, LONGLONG cmask){

	if ((BYTE*)dwp == (BYTE*)&(ver->dwMinorVersion)){	//	}Ci[o[W̌ł
		LONGLONG cmask = 0;
		cmask = VerSetConditionMask(cmask, VER_MAJORVERSION, VER_EQUAL);
		cmask = VerSetConditionMask(cmask, VER_MINORVERSION, VER_EQUAL);
		for (int n = 0; n < 65536; n++){
			*dwp = n;
			BOOL b;
			b = VerifyVersionInfo(ver, mask, cmask);
			if (b == TRUE)
				return;
		}
		*dwp = 0xffffffff;
		return;

	}else{
		UINT sum = 0;
		int bit_max = 15;
		UINT bit_chk = 1 << bit_max;
		while (0 <= bit_max){
			BOOL b;
			*dwp = sum | bit_chk;
			b = VerifyVersionInfo(ver, mask, cmask);
			if (b == TRUE)
				sum |= bit_chk;
			bit_chk >>= 1;
			--bit_max;
		}
		*dwp = sum;
	}
}

//	VerifyVersionInfo APIgOSVERINFOEX̎w肵WORD̒l擾

void getVerWord(OSVERSIONINFOEX* ver, WORD* wp, DWORD mask, LONGLONG cmask){
	UINT sum = 0;
	int bit_max = 15;
	UINT bit_chk = 1 << bit_max;
	while (0 <= bit_max){
		BOOL b;
		*wp = sum + bit_chk;
		b = VerifyVersionInfo(ver, mask, cmask);
		if (b == TRUE)
			sum += bit_chk;
		bit_chk >>= 1;
		--bit_max;
	}
	*wp = sum;
}

//	VerifyVersionInfo APIgOSVERINFOEX̎w肵BYTE̒l擾

void getVerByte(OSVERSIONINFOEX* ver, BYTE* bp, DWORD mask, LONGLONG cmask){
	UINT sum = 0;
	int bit_max = 15;
	UINT bit_chk = 1 << bit_max;
	while (0 <= bit_max){
		BOOL b;
		*bp = sum + bit_chk;
		b = VerifyVersionInfo(ver, mask, cmask);
		if (b == TRUE)
			sum += bit_chk;
		bit_chk >>= 1;
		--bit_max;
	}
	*bp = sum;
}